ShadowFriend = LibStub("AceAddon-3.0"):NewAddon("ShadowFriend", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("ShadowFriend")
local TalentQuery = LibStub:GetLibrary("LibTalentQuery-1.0")
local BB = LibStub("LibBabble-Boss-3.0")

-- ========================================================================== --
-- Combat log constants
-- ========================================================================== --
-- Affiliation
local COMBATLOG_OBJECT_AFFILIATION_MINE		= COMBATLOG_OBJECT_AFFILIATION_MINE		or 0x00000001
local COMBATLOG_OBJECT_AFFILIATION_PARTY	= COMBATLOG_OBJECT_AFFILIATION_PARTY	or 0x00000002
local COMBATLOG_OBJECT_AFFILIATION_RAID		= COMBATLOG_OBJECT_AFFILIATION_RAID		or 0x00000004
local COMBATLOG_OBJECT_AFFILIATION_OUTSIDER	= COMBATLOG_OBJECT_AFFILIATION_OUTSIDER	or 0x00000008
local COMBATLOG_OBJECT_AFFILIATION_MASK		= COMBATLOG_OBJECT_AFFILIATION_MASK		or 0x0000000F
-- Reaction
local COMBATLOG_OBJECT_REACTION_FRIENDLY	= COMBATLOG_OBJECT_REACTION_FRIENDLY	or 0x00000010
local COMBATLOG_OBJECT_REACTION_NEUTRAL		= COMBATLOG_OBJECT_REACTION_NEUTRAL		or 0x00000020
local COMBATLOG_OBJECT_REACTION_HOSTILE		= COMBATLOG_OBJECT_REACTION_HOSTILE		or 0x00000040
local COMBATLOG_OBJECT_REACTION_MASK		= COMBATLOG_OBJECT_REACTION_MASK		or 0x000000F0
-- Ownership
local COMBATLOG_OBJECT_CONTROL_PLAYER		= COMBATLOG_OBJECT_CONTROL_PLAYER		or 0x00000100
local COMBATLOG_OBJECT_CONTROL_NPC			= COMBATLOG_OBJECT_CONTROL_NPC			or 0x00000200
local COMBATLOG_OBJECT_CONTROL_MASK			= COMBATLOG_OBJECT_CONTROL_MASK			or 0x00000300
-- Unit type
local COMBATLOG_OBJECT_TYPE_PLAYER			= COMBATLOG_OBJECT_TYPE_PLAYER			or 0x00000400
local COMBATLOG_OBJECT_TYPE_NPC				= COMBATLOG_OBJECT_TYPE_NPC				or 0x00000800
local COMBATLOG_OBJECT_TYPE_PET				= COMBATLOG_OBJECT_TYPE_PET				or 0x00001000
local COMBATLOG_OBJECT_TYPE_GUARDIAN		= COMBATLOG_OBJECT_TYPE_GUARDIAN		or 0x00002000
local COMBATLOG_OBJECT_TYPE_OBJECT			= COMBATLOG_OBJECT_TYPE_OBJECT			or 0x00004000
local COMBATLOG_OBJECT_TYPE_MASK			= COMBATLOG_OBJECT_TYPE_MASK			or 0x0000FC00

-- Special cases (non-exclusive)
local COMBATLOG_OBJECT_TARGET				= COMBATLOG_OBJECT_TARGET				or 0x00010000
local COMBATLOG_OBJECT_FOCUS				= COMBATLOG_OBJECT_FOCUS				or 0x00020000
local COMBATLOG_OBJECT_MAINTANK				= COMBATLOG_OBJECT_MAINTANK				or 0x00040000
local COMBATLOG_OBJECT_MAINASSIST			= COMBATLOG_OBJECT_MAINASSIST			or 0x00080000
local COMBATLOG_OBJECT_RAIDTARGET1			= COMBATLOG_OBJECT_RAIDTARGET1			or 0x00100000
local COMBATLOG_OBJECT_RAIDTARGET2			= COMBATLOG_OBJECT_RAIDTARGET2			or 0x00200000
local COMBATLOG_OBJECT_RAIDTARGET3			= COMBATLOG_OBJECT_RAIDTARGET3			or 0x00400000
local COMBATLOG_OBJECT_RAIDTARGET4			= COMBATLOG_OBJECT_RAIDTARGET4			or 0x00800000
local COMBATLOG_OBJECT_RAIDTARGET5			= COMBATLOG_OBJECT_RAIDTARGET5			or 0x01000000
local COMBATLOG_OBJECT_RAIDTARGET6			= COMBATLOG_OBJECT_RAIDTARGET6			or 0x02000000
local COMBATLOG_OBJECT_RAIDTARGET7			= COMBATLOG_OBJECT_RAIDTARGET7			or 0x04000000
local COMBATLOG_OBJECT_RAIDTARGET8			= COMBATLOG_OBJECT_RAIDTARGET8			or 0x08000000
local COMBATLOG_OBJECT_NONE					= COMBATLOG_OBJECT_NONE					or 0x80000000
local COMBATLOG_OBJECT_SPECIAL_MASK			= COMBATLOG_OBJECT_SPECIAL_MASK			or 0xFFFF0000

-- School types
local SCHOOL_PHYSICAL	= 0x01
local SCHOOL_HOLY		= 0x02
local SCHOOL_FIRE		= 0x04
local SCHOOL_NATURE		= 0x08
local SCHOOL_FROST		= 0x10
local SCHOOL_SHADOW		= 0x20
local SCHOOL_ARCANE		= 0x40

-- ========================================================================== --
-- Useful constants
-- ========================================================================== --
-- Spell IDs
local SPELLID_SHADOWFORM = 15473
local SPELLID_VAMPIRICTOUCH = 34914
local SPELLID_IMPROVEDMINDBLAST = 15273
local SPELLID_MINDBLAST = 8092
local SPELLID_SHADOWWORDDEATH = 32379
-- Talent indexes
local TALENTTABINDEX_SHADOW = 3
local TALENTINDEX_IMPROVEDMINDBLAST = 7
local HISTORY_MAXSIZE = 8

-- ========================================================================== --
-- History table formatting constants
-- ========================================================================== --

local HISTORY_CONTENT_HEIGHT = 16
local HISTORY_CONTENT_WIDTH = 64
local HISTORY_COLHEADER_HEIGHT = 30
local HISTORY_ROWHEADER1_WIDTH = 60
local HISTORY_ROWHEADER2_WIDTH = 60
local HISTORY_CONTENT_OFFSETX = 20
local HISTORY_CONTENT_OFFSETY = -75
local HISTORY_CONTENT_PADDINGX = 0
local HISTORY_HEADER_PADDINGX = 3
local HISTORY_CONTENT_PADDINGY = 0
local HISTORY_HEADER_PADDINGY = 3
local HISTORY_TEXT_PADDINGX = 3
local HISTORY_TEXT_PADDINGY = 3
local HISTORY_DATANUMBER = 4
local HISTORY_WARNINGNUMBER = 4
local HISTORY_FONT_SIZE = 10
local HISTORY_FONT_FACE = [[Interface\AddOns\ShadowFriend\fonts\ABF.ttf]]
local HISTORY_WARNINGICON_WIDTH = 16
local HISTORY_WARNINGICON_HEIGHT = 16
local _, _, HISTORY_ICONPATH_HAZARDOUSSWD = GetSpellInfo(SPELLID_SHADOWWORDDEATH)
local HISTORY_ICONPATH_DEATHS = "Interface\\Icons\\Ability_Rogue_FeignDeath"

-- ========================================================================== --
-- Default Database
-- ========================================================================== --
defaultsDb = {
    profile = {
        hazardousSWDThreshold = 50,
        onlyNonTrivial = false,
        debug = false,
        history = {},
        historySelectedBoss = "",
        historyFrameX = 0,
        historyFrameY = 0,
        historySize = HISTORY_MAXSIZE,
        bossList = {},
        mbThreshold = 60,
        vtThreshold = 90,
        swdThreshold = 0,
    }
}    

-- ========================================================================== --
-- Option table initialization
-- ========================================================================== --

ShadowFriend.options = {
    name = "ShadowFriend",
    handler = ShadowFriend,
    type = 'group',
    childGroups = "tab",
    args = {
    	config={ -- Hidden in GUI, only displayed in command line
    		order = 0,
    		name = L["options_config_name"],
			desc = L["options_config_desc"],
			type = "execute",
			func = function(info)
				InterfaceOptionsFrame_OpenToFrame(ShadowFriend.optionsFrame)
			end,
			guiHidden = true
		},
		sh={ -- Hidden in GUI, only displayed in command line
    		order = 0,
    		name = L["options_showhistory_name"],
			desc = L["options_showhistory_desc"],
			type = "execute",
			func = function(info)
				if ShadowFriend.historyFrame and ShadowFriend.historyFrame:IsShown() then
					ShadowFriend.historyFrame:Hide()
				else
					ShadowFriend:showHistoryFrame()
				end
			end,
			guiHidden = true
		},
		generalTab= { -- Grouping for GUI
    		order = 1,
    		name = L["options_generaltab_name"],
			type = "group",
			cmdInline = true,
			args = {
				general= { -- Grouping for GUI
		    		order = 1,
		    		name = L["options_general_name"],
					type = "group",
					guiInline = true,
					cmdInline = true,
					args = {
						debug= {
							order = 1,
				    		name = L["options_general_debug_name"],
							desc = L["options_general_debug_desc"],
							type = "toggle",
							set = function(info, val) ShadowFriend.db.profile.debug = val; end,
							get = function(info) return ShadowFriend.db.profile.debug; end,
						},
						onlyNonTrivial={
							order = 2,
				    		name = L["options_general_onlynontrivial_name"],
							desc = L["options_general_onlynontrivial_desc"],
							type = "toggle",
							set = function(info, val) 
								ShadowFriend.db.profile.onlyNonTrivial = val
							end,
							get = function(info) return ShadowFriend.db.profile.onlyNonTrivial; end,
						},
						historySize={
							order = 4,
				    		name = L["options_general_historysize_name"],
							desc = L["options_general_historysize_desc"],
							type = "range",
							min = 1,
							max = HISTORY_MAXSIZE,
							step = 1,
							set = function(info, val) 
								ShadowFriend.db.profile.historySize = val
							end,
							get = function(info) return ShadowFriend.db.profile.historySize; end,
						},
					}
				},
				swd={ -- Grouping for GUI
		    		order = 2,
		    		name = L["options_swd_name"],
					type = "group",
					guiInline = true,
					cmdInline = true,
					hidden = function()
						return an
					end,
					args = {
						swdThreshold={
							order = 12,
				    		name = L["options_swd_threshold_name"],
							desc = L["options_swd_threshold_desc"],
							type = "range",
							min = 0,
							max = 100,
							step = 5,
							set = function(info, val) ShadowFriend.db.profile.hazardousSWDThreshold = val; end,
							get = function(info) return ShadowFriend.db.profile.hazardousSWDThreshold; end,
						},
					}
				},
				emphasize = { -- Grouping for Emphasize
		    		order = 3,
		    		name = L["options_emphasize_name"],
					type = "group",
					guiInline = true,
					hidden = function()
						return an
					end,
					args = {
						vtThreshold={
							order = 1,
				    		name = L["options_emphasize_vt_name"],
							desc = L["options_emphasize_vt_desc"],
							type = "range",
							min = 0,
							max = 100,
							step = 5,
							set = function(info, val) ShadowFriend.db.profile.vtThreshold = val; end,
							get = function(info) return ShadowFriend.db.profile.vtThreshold; end,
						},
						mbThreshold={
							order = 2,
				    		name = L["options_emphasize_mb_name"],
							desc = L["options_emphasize_mb_desc"],
							type = "range",
							min = 0,
							max = 100,
							step = 5,
							set = function(info, val) ShadowFriend.db.profile.mbThreshold = val; end,
							get = function(info) return ShadowFriend.db.profile.mbThreshold; end,
						},
						swdThreshold={
							order = 3,
				    		name = L["options_emphasize_swd_name"],
							desc = L["options_emphasize_swd_desc"],
							type = "range",
							min = 0,
							max = 100,
							step = 5,
							set = function(info, val) ShadowFriend.db.profile.swdThreshold = val; end,
							get = function(info) return ShadowFriend.db.profile.swdThreshold; end,
						},
					}
				},
			}
		},
		bossDefinition= { -- Grouping for GUI
    		order = 2,
    		name = L["options_bosstab_name"],
			type = "group",
			hidden = function()
				return not ShadowFriend.db.profile.onlyNonTrivial
			end,
			args = {
				addBoss = {
					name = L["options_addmob_name"],
					desc = L["options_addmob_desc"],
					type = "input",
					width = "double",
					get = function(info) return ""; end,
					set = function(info, val)
						if val == "" then return; end
						local options = ShadowFriend.options.args.bossDefinition.args
						if not options[string.gsub(val, " ", "")] then
							options[string.gsub(val, " ", "")] = ShadowFriend:getBossDefinitionOption(val)
							ShadowFriend.db.profile.bossList[val] = val
						end
					end,
				},
				addBossFromTarget = {
					name = L["options_addmobfromtarget_name"],
					desc = L["options_addmobfromtarget_desc"],
					type = "execute",
					func = function(info)
						local val = UnitName("target")
						if val == nil then return; end
						local options = ShadowFriend.options.args.bossDefinition.args
						if not options[string.gsub(val, " ", "")] then
							options[string.gsub(val, " ", "")] = ShadowFriend:getBossDefinitionOption(val)
							ShadowFriend.db.profile.bossList[val] = val
						end
					end,
				},
				loadDungeonSelect = {
					name = L["options_loaddungeon_select_name"],
					desc = L["options_loaddungeon_select_desc"],
					type = "select",
					cmdHidden = true,
					values = function()
						local dungeonList = {}
						for dungeon, _ in pairs(ShadowFriend_dungeonDatabase) do
							dungeonList[dungeon] = dungeon
						end
						return dungeonList
					end,
					get = function(info) return ShadowFriend.selectedDungeonToLoad; end,
					set = function(info, val)
						ShadowFriend.selectedDungeonToLoad = val
					end,
				},
				loadDungeonButton = {
					name = L["options_loaddungeon_load_name"],
					desc = L["options_loaddungeon_load_desc"],
					type = "execute",
					cmdHidden = true,
					func = function(info)
						local mobList = ShadowFriend_dungeonDatabase[ShadowFriend.selectedDungeonToLoad]
						for mob, dungeon in pairs(mobList) do
							ShadowFriend.db.profile.bossList[mob] = dungeon
						end
						ShadowFriend.selectedDungeonToLoad = nil
						ShadowFriend:getBossDefinitionOptions()
					end,
				},
			}
		},
    },
}

function ShadowFriend:getBossDefinitionOptions()
	local options = self.options.args.bossDefinition.args
	local bossList = self.db.profile.bossList
	
	for bossName, _ in  pairs(bossList) do
		options[string.gsub(bossName, " ", "")] = self:getBossDefinitionOption(bossName)
	end 
end

function ShadowFriend:deleteBossDefinitionOptions(bossOptionName)
	local options = ShadowFriend.options.args.bossDefinition.args
	options[bossOptionsName] = nil
end

function ShadowFriend:getBossDefinitionOption(bossName)
	local option = {
		name = bossName,
		type = "group",
		args = {
			encounterName = {
				name = L["options_encountername_name"],
				desc = L["options_encountername_desc"],
				type = "input",
				width = "double",
				get = function(info) return ShadowFriend.db.profile.bossList[bossName]; end,
				set = function(info, val)
					ShadowFriend.db.profile.bossList[bossName] = val
				end,
			},
			encounterNameDropdown = {
				name = L["options_encountername_name"],
				desc = L["options_encountername_desc"],
				type = "select",
				width = "double",
				cmdHidden = true,
				values = function()
					local bossList = ShadowFriend.db.profile.bossList
					local bossEncounterList = {}
					for _, bossEncounter in pairs(bossList) do
						bossEncounterList[bossEncounter] = bossEncounter
					end
					return bossEncounterList
				end,
				get = function(info) return ShadowFriend.db.profile.bossList[bossName]; end,
				set = function(info, val)
					ShadowFriend.db.profile.bossList[bossName] = val
				end,
			},
			delete = {
				name = L["options_deletemob_name"],
				desc = L["options_deletemob_desc"],
				type = "execute",
				arg = bossName,
				func = function(info)
					local options = ShadowFriend.options.args.bossDefinition.args
					if options[string.gsub(info.arg, " ", "")] then
						options[string.gsub(info.arg, " ", "")] = nil
					end
					ShadowFriend.db.profile.bossList[info.arg] = nil
				end,
			}
		},
	}
	return option
end

-- ========================================================================== --
-- Addon loading events override
-- ========================================================================== --

function ShadowFriend:OnInitialize() -- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("ShadowFriendDB", defaultsDb, "Default")
	-- Generating option table (boss definition)
	self:getBossDefinitionOptions()
	-- Registering option table
    LibStub("AceConfig-3.0"):RegisterOptionsTable("ShadowFriend", ShadowFriend.options)
    -- Adding config GUI to Blizzard options
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ShadowFriend", "ShadowFriend")
    -- Registering chat commands
    self:RegisterChatCommand("shadowfriend", "ChatCommand")
    self:RegisterChatCommand("sfriend", "ChatCommand")
	-- Initializing attributes
	self.isRecording = false
	self.recordingStat = {}
	self.recordingStart = 0
	self.recordingStop = 0
	self.recordingBossName = ""
	self.improvedMBInvestment = {}
end

function ShadowFriend:OnEnable()
    -- Events registration
    ShadowFriend:registerRecordingTrigger()
    -- Callback for talent query
    TalentQuery.RegisterCallback(self, "TalentQuery_Ready")
end

-- Called when the addon is disabled
function ShadowFriend:OnDisable()
    -- Callback for talent query
    TalentQuery.UnregisterCallback(self, "TalentQuery_Ready")
end

-- ========================================================================== --
-- Events handlers
-- ========================================================================== --

-- Handle slash commands
function ShadowFriend:ChatCommand(input)
	-- open GUI when slash command used with "config" args, handle args else
    if input:trim() == "config" then
        LibStub("AceConfigDialog-3.0"):Open("ShadowFriend")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(ShadowFriend, "sfriend", "ShadowFriend", input)
    end
end

-- Handle Combat Log Events
function ShadowFriend:handleCombatLogEvent(_,timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	-- Get all shadow damage done by shadowpriests --
	local raidMemberMask = COMBATLOG_OBJECT_AFFILIATION_MINE+COMBATLOG_OBJECT_AFFILIATION_PARTY+COMBATLOG_OBJECT_AFFILIATION_RAID
	local playerMask = COMBATLOG_OBJECT_TYPE_PLAYER
	local hostileNPCMask = COMBATLOG_OBJECT_REACTION_HOSTILE+COMBATLOG_OBJECT_TYPE_NPC
	if bit.band(srcFlags, raidMemberMask)~=0 and
		bit.band(srcFlags, playerMask) == playerMask and
	 	bit.band(dstFlags, hostileNPCMask) == hostileNPCMask
	 	then -- filter out combat log events that aren't of type raidMember -> ennemy NPC
	 	--  filter out non SP
	 	if self.recordingStat[srcName] then
		 	-- filter out non SPELL_DAMAGE / SPELL_PERIODIC_DAMAGE damage
		 	if eventtype == "SPELL_DAMAGE" or eventtype == "SPELL_PERIODIC_DAMAGE" then
		 		local _, spellName, _, amount, school = ...
		 		-- If school is shadow add damage done to total shadow dmg
	 			if school == SCHOOL_SHADOW then
	 				self.recordingStat[srcName].shadowDmg = self.recordingStat[srcName].shadowDmg + amount
				end
				-- If spell is Mind Blast increment counter
				if spellName == GetSpellInfo(SPELLID_MINDBLAST) then
					self.recordingStat[srcName].mbNumber = self.recordingStat[srcName].mbNumber + 1
					return
				end
				-- If spell is Shadow Word: Death
				if spellName == GetSpellInfo(SPELLID_SHADOWWORDDEATH) then
					-- Increment Counter
					self.recordingStat[srcName].swdNumber = self.recordingStat[srcName].swdNumber + 1
					-- Check unit health and increment counter if needed
					if GetNumRaidMembers()>0 then
						for i = 1, 40 do
							self:incrementCounterIfHazardous("raid"..i, srcName)
						end
					else
						if GetNumPartyMembers() > 0 then
							for i = 1, 4 do
								self:incrementCounterIfHazardous("party"..i, srcName)
							end
						end
						self:incrementCounterIfHazardous("player", srcName)
					end
					
					return
				end
				return
		 	elseif eventtype == "SPELL_MISSED" then
		 		local _, spellName = ...
		 		-- If spell is Mind Blast increment counter
				if spellName == GetSpellInfo(SPELLID_MINDBLAST) then
					self.recordingStat[srcName].mbNumber = self.recordingStat[srcName].mbNumber + 1
					return
				end
				-- If spell is Shadow Word: Death
				if spellName == GetSpellInfo(SPELLID_SHADOWWORDDEATH) then
					-- Increment Counter
					self.recordingStat[srcName].swdNumber = self.recordingStat[srcName].swdNumber + 1
					-- Check unit health and increment counter if needed
					if GetNumRaidMembers()>0 then
						for i = 1, 40 do
							self:incrementCounterIfHazardous("raid"..i, srcName)
						end
					else
						if GetNumPartyMembers() > 0 then
							for i = 1, 4 do
								self:incrementCounterIfHazardous("party"..i, srcName)
							end
						end
						self:incrementCounterIfHazardous("player", srcName)
					end
					
					return
				end
			end
		end
	end
	
	-- Get all mana gain due to priest VT
	if bit.band(srcFlags, raidMemberMask)~=0 and
		bit.band(srcFlags, playerMask) == playerMask and
	 	bit.band(dstFlags, raidMemberMask)~=0 and
		bit.band(dstFlags, playerMask) == playerMask
	 	then -- filter out combat log events that aren't of type raidMember -> raidMember
	 	--  filter out non SP and non src = dst events
	 	if self.recordingStat[srcName] and srcGUID == dstGUID then
	 		-- filter out non SPELL_PERIODIC_ENERGIZE
		 	if eventtype == "SPELL_PERIODIC_ENERGIZE" then
		 		local _, spellName, _, amount = ...
	 			if spellName == GetSpellInfo(SPELLID_VAMPIRICTOUCH) then
	 				self.recordingStat[srcName].vtManaGained = self.recordingStat[srcName].vtManaGained + amount
	 				return
				end 
		 	end
		end
	end
	
	-- Get all deaths
	if bit.band(dstFlags, raidMemberMask)~=0 and
		bit.band(dstFlags, playerMask) == playerMask
	 	then -- filter out combat log events that aren't of type raidMember -> ennemy NPC
	 	--  filter out non SP
	 	if self.recordingStat[dstName] then
	 		-- filter out non UNIT_DIED
		 	if eventtype == "UNIT_DIED" then
		 		self.recordingStat[dstName].deaths = self.recordingStat[dstName].deaths + 1
		 	end
	 	end
	end
end

-- Handle LibTalentQuery-1.0 TalentQuery_Ready event
function ShadowFriend:TalentQuery_Ready(_, name)
	local isNotPlayer = (UnitName("player")~=name)
	local nameTalent, _, _, _, currentRank = GetTalentInfo(TALENTTABINDEX_SHADOW, TALENTINDEX_IMPROVEDMINDBLAST, isNotPlayer)
	if nameTalent and nameTalent == GetSpellInfo(SPELLID_IMPROVEDMINDBLAST) then
		self:debug(nameTalent .. " for " .. name .. " : " .. currentRank)
	end
	self.improvedMBInvestment[name] = currentRank
end

-- Returns true if target must be kept
function ShadowFriend:checkRetentionTarget()
	if self.db.profile.onlyNonTrivial then
		if self.db.profile.bossList[UnitName("target")] then
			self.recordingBossName = self.db.profile.bossList[UnitName("target")]
			self:UnregisterEvent("PLAYER_TARGET_CHANGED")
			return true
		end
	else
		if UnitAffectingCombat("target") and UnitIsEnemy("player", "target") then
			self.recordingBossName = UnitName("target")
			self:UnregisterEvent("PLAYER_TARGET_CHANGED")
			return true
		end
	end
end

-- ========================================================================== --
-- Miscellaneous Methods
-- ========================================================================== --

-- Output Debug messages if debug is on or warning flag is up
function ShadowFriend:debug(msg, flagWarning)
	if flagWarning then
		self:Print(format("%s : %s", L["Warning"], msg))
	elseif self.db.profile.debug then
		self:Print(msg)
	end
end

-- Sets the events that turn recording on/off
function ShadowFriend:registerRecordingTrigger()
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "startRecording")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "checkForWipe")
end

function ShadowFriend:startRecording()
	if not self.isRecording then
		self.isRecording = true
		
		-- Save recording start time
		self.recordingStart = time()
		
		-- Save encounter name
		self.recordingBossName = "UNKNOWN"  -- The encounter will be saved only if recordingBossName is not "UNKNOWN"
		if not self:checkRetentionTarget() then
			self:RegisterEvent("PLAYER_TARGET_CHANGED", "checkRetentionTarget")
		end
		
		self:debug("Starting data gathering for " .. self.recordingBossName)
		
		-- Register events
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "handleCombatLogEvent")
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "handleCombatLogEvent")
		
		-- Get all shadowpriests in raid/group based on Shadowform buff
		if GetNumRaidMembers()>0 then
			for i = 1, 40 do
				self:initIfShadowForm("raid"..i)
			end
		else
			if GetNumPartyMembers() > 0 then
				for i = 1, 4 do
					self:initIfShadowForm("party"..i)
				end
			end
			self:initIfShadowForm("player")
		end
	end
end

-------------------------------------------------
-- Wipe Detection shamelessly ripped from BigWigs
function ShadowFriend:checkForWipe()
	self:debug("Checking for wipe")
	if not UnitIsFeignDeath("player") then
		local go = self:scan()
		if not go then
			self:debug("Wipe detected")
			self:stopRecording()
			return
		end
	end

	if not UnitAffectingCombat("player") then
		self:ScheduleTimer(self.checkForWipe, 2, self)
		self:debug("Scheduling checkForWipe")
	end
end

function ShadowFriend:scan()
	if not self.scanTableIsPopulated then self:populateScanTable(self) end

	if UnitExists("target") and UnitAffectingCombat("target") and self.scanTable[UnitName("target")] then
		return "target"
	end

	if UnitExists("focus") and UnitAffectingCombat("focus") and self.scanTable[UnitName("focus")] then
		return "focus"
	end

	local num = GetNumRaidMembers()
	if num == 0 then
		num = GetNumPartyMembers()
		for i = 1, num do
			local partyUnit = string.format("%s%d%s", "party", i, "target")
			if UnitExists(partyUnit) and UnitAffectingCombat(partyUnit) and self.scanTable[UnitName(partyUnit)] then
				return partyUnit
			end
		end
	else
		for i = 1, num do
			local raidUnit = string.format("%s%d%s", "raid", i, "target")
			if UnitExists(raidUnit) and UnitAffectingCombat(raidUnit) and self.scanTable[UnitName(raidUnit)] then
				return raidUnit
			end
		end
	end
end

function ShadowFriend:populateScanTable(mod)
	self.scanTable = {}
	if self.recordingBossName == "UNKNOWN" then
		return
	else
		self.scanTableIsPopulated = true
	end
	
	for mobName, bossName in pairs(self.db.profile.bossList) do
		if bossName == self.recordingBossName then
			self.scanTable[mobName] = true
		end
	end
end

function ShadowFriend:initIfShadowForm(unit)
	if UnitExists(unit) then
		local buffIndex = 1
		local buffName = UnitBuff(unit, buffIndex)
		while buffName do
			if buffName == GetSpellInfo(SPELLID_SHADOWFORM) then
				self:initInfoForUnit(unit)
			end
			buffIndex = buffIndex + 1
			buffName = UnitBuff(unit, buffIndex)
		end
	end
end

function ShadowFriend:initInfoForUnit(unit)
	local name = UnitName(unit)
	
	-- Add to shadowpriest list for this fight
	self:debug(name .. " added to shadowpriest list for this fight")
	self.recordingStat[name] = {
		shadowDmg = 0,
		vtManaGained = 0,
		mbNumber = 0,
		swdNumber = 0,
		hazardousSwdNumber = 0,
		deaths = 0,
	}
	
	-- Get talent point investment for Improved Mindblast if not already known
	if not self.improvedMBInvestment[name] then
		if name==UnitName("player") then
			self:TalentQuery_Ready(_, name)
		else
			TalentQuery:Query(unit)
		end
	end
end

function ShadowFriend:stopRecording()
	if self.isRecording then
		self.isRecording = false
		self.scanTableIsPopulated = false
		
		-- Save recording stop time
		self.recordingStop = time()
	
		-- Unregister events
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		-- Unregister the target change if not done already (in non "non trivial only" case)
		self:UnregisterEvent("PLAYER_TARGET_CHANGED")
		
		-- Historize fight if boss name is not UNKNOWN
		if self.recordingBossName ~= "UNKNOWN" then
			self:debug("Historizing fight")
			self:historyPush()
		else
			self:debug("Fight not historized")
		end
	end
end

function ShadowFriend:incrementCounterIfHazardous(unit, name)
	if UnitExists(unit) then
		if name == UnitName(unit) then
			local unitHealthPct = UnitHealth(unit) / UnitHealthMax(unit) * 100
			
			if unitHealthPct < self.db.profile.hazardousSWDThreshold then
				self.recordingStat[name].hazardousSwdNumber = self.recordingStat[name].hazardousSwdNumber + 1
			end
		end
	end
end

-- ========================================================================== --
-- GUI functions
-- ========================================================================== --
 
-- Create History Frame
function ShadowFriend:createHistoryFrame()
	----------------------------------------------------------------------------
	-- Create Frame and set basic stuff
	ShadowFriend.historyFrame=CreateFrame("Frame","ShadowFriend_historyFrame",UIParent)
				
	local theFrame=ShadowFriend.historyFrame

	theFrame:ClearAllPoints()
	theFrame:SetPoint("CENTER",UIParent)--, self.db.profile.historyFrameX, self.db.profile.historyFrameY)
	theFrame:SetHeight(320+26)
	theFrame:SetWidth(60 +
		HISTORY_ROWHEADER1_WIDTH + HISTORY_HEADER_PADDINGX +
		HISTORY_ROWHEADER2_WIDTH + HISTORY_HEADER_PADDINGX +
		(HISTORY_CONTENT_WIDTH + HISTORY_CONTENT_PADDINGX) * HISTORY_MAXSIZE
	)
	
	-- TODO cleanup textures from recount
	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = "Interface\\AddOns\\ShadowFriend\\textures\\otravi-semi-full-border",
		edgeSize = 32,
		insets = {left = 1, right = 1, top = 20, bottom = 1},
	})
	theFrame:SetBackdropBorderColor(1.0,0.0,0.0)
	theFrame:SetBackdropColor(24/255, 24/255, 24/255)
	
	----------------------------------------------------------------------------
	-- Move frame
	theFrame:EnableMouse(true)
	theFrame:SetMovable(true)

	theFrame:SetScript("OnMouseDown", function() 
		if ( ( ( not this.isLocked ) or ( this.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
			this:StartMoving();
			this.isMoving = true;
		end
	end)
	theFrame:SetScript("OnMouseUp", function() 
		if ( this.isMoving ) then
			local point,relativeTo,relativePoint,xOfs,yOfs = this:GetPoint(1)
			ShadowFriend.db.profile.historyFrameX=xOfs
			ShadowFriend.db.profile.historyFrameY=yOfs
			this:StopMovingOrSizing();
			this.isMoving = false;
		end
	end)
					
	theFrame:SetScript("OnHide", function()
		if ( this.isMoving ) then
			  local point,relativeTo,relativePoint,xOfs,yOfs = this:GetPoint(1)
			  Recount.db.profile.historyFrameX=xOfs
			  Recount.db.profile.historyFrameY=yOfs
			  this:StopMovingOrSizing();
			  this.isMoving = false;
		end
	end)
	
	----------------------------------------------------------------------------
	-- Create faux scroll frame horizontal
	--[[theFrame.scrollBar=CreateFrame("SCROLLFRAME","ShadowFriend_historyFrame_scroll",theFrame,"FauxScrollFrameTemplate")
	--theFrame.scrollBar:SetScript("OnHorizontalScroll", function() FauxScrollFrame_OnHorizontalScroll(12, me.RefreshStatusBars) end)
	theFrame.scrollBar:SetPoint("TOPLEFT",theFrame,"TOPLEFT", 0, HISTORY_CONTENT_OFFSETY)	
	theFrame.scrollBar:SetPoint("BOTTOMRIGHT",theFrame,"BOTTOMRIGHT", -40, 5)
	ShadowFriend:SetupScrollbar("ShadowFriend_historyFrame_scroll")]]--	
	
	----------------------------------------------------------------------------
	-- Create title string
	theFrame.Title=theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	theFrame.Title:SetPoint("TOPLEFT",theFrame,"TOPLEFT",6,-15)
	theFrame.Title:SetTextColor(1.0,1.0,1.0,1.0)
	theFrame.Title:SetText(L["History_Frame_Title"])
	
	----------------------------------------------------------------------------
	-- Close button
	theFrame.CloseButton=CreateFrame("Button",nil,theFrame)
	theFrame.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
	theFrame.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
	theFrame.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	theFrame.CloseButton:SetWidth(20)
	theFrame.CloseButton:SetHeight(20)
	theFrame.CloseButton:SetPoint("TOPRIGHT",theFrame,"TOPRIGHT",-4,-12)
	theFrame.CloseButton:SetScript("OnClick",function()
		this:GetParent():Hide() 
	end)
	
	----------------------------------------------------------------------------
	-- Dropdown menu
	theFrame.encounterList = CreateFrame("Frame", "ShadowFriend_History_EncounterList", theFrame, "UIDropDownMenuTemplate")
	theFrame.encounterList:SetPoint("TOPLEFT",theFrame,"TOPLEFT",0,-40)
	UIDropDownMenu_SetWidth(130, theFrame.encounterList)
	local selectedIndex = 0
	UIDropDownMenu_Initialize(theFrame.encounterList, function()
		for encounter, _ in pairs(ShadowFriend.db.profile.history) do
			local info = UIDropDownMenu_CreateInfo()
		    info.text = encounter
			info.value = encounter
			info.func = ShadowFriend.historySelectBoss
			info.owner = this:GetParent()
			info.checked = nil  
			UIDropDownMenu_AddButton(info, 1)
		end
	end)
	local selectedIndex = nil
	local i = 1
	for encounter, _ in pairs(ShadowFriend.db.profile.history) do
		if ShadowFriend.db.profile.historySelectedBoss == encounter then
			selectedIndex = i
		end
		i = i + 1
	end
	UIDropDownMenu_SetSelectedID(theFrame.encounterList, selectedIndex)
	
	----------------------------------------------------------------------------
	-- Delete data button
	theFrame.deleteButton = CreateFrame("Button", "ShadowFriend_History_DeleteButton", theFrame)
	theFrame.deleteButton:SetPoint("TOPLEFT",theFrame,"TOPLEFT", 170, -45)
	theFrame.deleteButton:SetNormalTexture("Interface\\Addons\\Recount\\Textures\\icon-reset")
	theFrame.deleteButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	theFrame.deleteButton:SetWidth(16)
	theFrame.deleteButton:SetHeight(16)
	theFrame.deleteButton:SetScript("OnClick", function()
		local selectedIndex = nil
		local i = 1
		for encounter, _ in pairs(ShadowFriend.db.profile.history) do
			if ShadowFriend.db.profile.historySelectedBoss ~= encounter then
				selectedIndex = i
				break
			end
			i = i + 1
		end
		UIDropDownMenu_SetSelectedID(theFrame.encounterList, selectedIndex)
		ShadowFriend:deleteHistorySelectedBoss()
		ShadowFriend:refreshHistoryContent()
	end)
	-- SET tooltip
	theFrame.deleteButton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText(L["delete_encounter_tooltip"])
		GameTooltip:Show()
	end)
	theFrame.deleteButton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	
	-- Initialize the different tables and objects table
	self.historyFrame.encounterFrames = {}
	self.historyFrame.dataBgFrames = {}
	self.historyFrame.actorBgFrames = {}
	-- create permanent frames
	self.historyFrame.columnHeaderBgFrame = self:createColumnHeaderBgFrame()
	for statIndex = 1, HISTORY_DATANUMBER do
		self.historyFrame.dataBgFrames[statIndex] = self:createDataBgFrames(statIndex)
	end
	self.historyFrame.rowHeaderBgFrame = self:createRowHeaderBgFrame()
end

-- Open (create if not exists) history frame
function ShadowFriend:showHistoryFrame()
	if not self.historyFrame then
		self:createHistoryFrame()
	end
	self:refreshHistoryContent()
	self.historyFrame:Show()
end

-- Function to execute when selecting value in encounter dropdown
function ShadowFriend:historySelectBoss()
	if not self then self = ShadowFriend; end
	UIDropDownMenu_SetSelectedValue(this.owner, this.value)
	self.db.profile.historySelectedBoss = this.value
	self:refreshHistoryContent()
end

-- Refresh history frame content
function ShadowFriend:refreshHistoryContent()
	if not self then self = ShadowFriend; end
	
	local encounters = self.db.profile.history[self.db.profile.historySelectedBoss]
	
	if not encounters then return; end
	
	-- Compute index of line number for each player registered for this encounter
	local actorListByName = {}
	for i=1, #encounters do
		for nameActor, _ in pairs(encounters[i].actor) do
			if not actorListByName[nameActor] then
				actorListByName[nameActor] = true
			end
		end
	end
	local actorListByIndex = {}
	for actorName, _ in pairs(actorListByName) do
		table.insert(actorListByIndex, actorName)
	end
	
	-- Hide the Delete button if there's only one boss left
	local tableLength = 0
	for _,_ in pairs(self.db.profile.history) do
		tableLength = tableLength + 1
	end
	if tableLength == 1 then
		self.historyFrame.deleteButton:Hide()
	else
		self.historyFrame.deleteButton:Show()
	end
	
	----------------------------------------------
	-- Display the column header background frame
	local theFrame = self.historyFrame.columnHeaderBgFrame
	theFrame:SetWidth((HISTORY_CONTENT_WIDTH + HISTORY_CONTENT_PADDINGX) * #encounters)
	
	----------------------------------------------
	-- Display the row header background frame
	local theFrame = self.historyFrame.rowHeaderBgFrame
	theFrame:SetHeight(
		HISTORY_CONTENT_HEIGHT*#actorListByIndex*HISTORY_DATANUMBER + 
		HISTORY_CONTENT_PADDINGY*(#actorListByIndex - 1) +
		HISTORY_HEADER_PADDINGY*(HISTORY_DATANUMBER - 1)
	)
	
	----------------------------------------------
	-- Display the Row header (data type) background frame
	for statIndex = 1, HISTORY_DATANUMBER do
		local theFrame = self.historyFrame.dataBgFrames[statIndex]
		-- Main frame Position + set width and height
		theFrame:SetPoint("TOPLEFT", self.historyFrame, "TOPLEFT", 
			HISTORY_CONTENT_OFFSETX,
			HISTORY_CONTENT_OFFSETY -
				HISTORY_COLHEADER_HEIGHT - HISTORY_HEADER_PADDINGY -
				(HISTORY_CONTENT_HEIGHT * #actorListByIndex + HISTORY_CONTENT_PADDINGY * (#actorListByIndex - 1) + HISTORY_HEADER_PADDINGY) * (statIndex - 1)
		)
		theFrame:SetWidth(
			HISTORY_ROWHEADER1_WIDTH + HISTORY_HEADER_PADDINGX +
			HISTORY_ROWHEADER2_WIDTH + HISTORY_HEADER_PADDINGX +
			(HISTORY_CONTENT_WIDTH + HISTORY_CONTENT_PADDINGX) * #encounters
		)
		theFrame:SetHeight(
			HISTORY_CONTENT_HEIGHT * #actorListByIndex + 
			HISTORY_CONTENT_PADDINGY * (#actorListByIndex - 1)
		)
		-- Update fontString positionning
		theFrame.title:SetPoint("TOPLEFT",theFrame,"TOPLEFT", 
			HISTORY_TEXT_PADDINGX, 
			-theFrame:GetHeight()/2-HISTORY_TEXT_PADDINGY+HISTORY_CONTENT_HEIGHT/2
		)
		-- Update fontstrings content for stat
		theFrame.title:SetText(L["History_Frame_Stat" .. statIndex])
		-- Tooltip frame Position + set width and height
		theFrame.tooltipFrame:SetPoint("TOPLEFT", theFrame, "TOPLEFT", 0, 0)
		theFrame.tooltipFrame:SetWidth(HISTORY_ROWHEADER1_WIDTH + HISTORY_HEADER_PADDINGX)
		theFrame.tooltipFrame:SetHeight(
			HISTORY_CONTENT_HEIGHT * #actorListByIndex + 
			HISTORY_CONTENT_PADDINGY * (#actorListByIndex - 1)
		)
		-- Update description (displayed by tolltip)
		theFrame.tooltipFrame.description = L["History_Frame_Stat" .. statIndex .. "_desc"]
	end
	
	----------------------------------------------
	-- Display the Row header (actors) background frame
	for actorIndex = 1, #actorListByIndex do
		if not self.historyFrame.actorBgFrames[actorIndex] then
			self.historyFrame.actorBgFrames[actorIndex] = self:createActorBgFrames(actorIndex)
		end
		for dataIndex = 1, HISTORY_DATANUMBER do 
			local theFrame = self.historyFrame.actorBgFrames[actorIndex][dataIndex]
			local fontOffsetY = HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
				(HISTORY_CONTENT_HEIGHT * #actorListByIndex + HISTORY_CONTENT_PADDINGY * (#actorListByIndex -1) + HISTORY_HEADER_PADDINGY) * (dataIndex -1) +
				(HISTORY_CONTENT_HEIGHT + HISTORY_CONTENT_PADDINGY) * (actorIndex - 1)
			theFrame:SetPoint("TOPLEFT", self.historyFrame, "TOPLEFT", 
				HISTORY_CONTENT_OFFSETX + 
					HISTORY_ROWHEADER1_WIDTH + HISTORY_HEADER_PADDINGX ,
				HISTORY_CONTENT_OFFSETY - fontOffsetY
			)
			theFrame:SetWidth(
				HISTORY_ROWHEADER2_WIDTH + HISTORY_HEADER_PADDINGX +
				(HISTORY_CONTENT_WIDTH + HISTORY_CONTENT_PADDINGX) * #encounters
			)
			theFrame:SetBackdropColor(200/255, 200/255, 255/255, 0.25 * ((actorIndex + dataIndex*#actorListByIndex) % 2))
			
			theFrame.title:SetText(actorListByIndex[actorIndex])
			theFrame:Show()
		end
	end
	-- Cleanup unused frames (we conserve them for performance reasons)
	for actorIndex = #actorListByIndex+1, #self.historyFrame.actorBgFrames do
		for dataIndex = 1, HISTORY_DATANUMBER do
			local theFrame = self.historyFrame.actorBgFrames[actorIndex][dataIndex]
			theFrame:Hide()
		end
	end	
	
	----------------------------------------
	-- Display the encounter frame
	for colIndex, encounter in pairs(encounters) do
		if not self.historyFrame.encounterFrames[colIndex] then
			self.historyFrame.encounterFrames[colIndex] = self:createEncounterFrame(colIndex)
		end
		
		local encounterFrame = self.historyFrame.encounterFrames[colIndex]
		encounterFrame:SetHeight(
			HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
			HISTORY_CONTENT_HEIGHT*#actorListByIndex*HISTORY_DATANUMBER + 
			HISTORY_CONTENT_PADDINGY*(#actorListByIndex - 1) +
			HISTORY_HEADER_PADDINGY*(HISTORY_DATANUMBER - 1)
		)
		encounterFrame.tooltipFrame:SetHeight(HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY)
		
		encounterFrame.title1:SetText(encounter.date)
		encounterFrame.title2:SetText(encounter.time)
		
		-- SET tooltip
		encounterFrame.tooltipFrame.description = string.format(L["encounter_tooltip"], encounter.length / 60, encounter.length % 60)
		encounterFrame.tooltipFrame:EnableMouse(true)
		encounterFrame.tooltipFrame:SetScript("OnEnter", function()
			GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
			GameTooltip:ClearLines()
			GameTooltip:SetText(this.description)
			GameTooltip:Show()
		end)
		encounterFrame.tooltipFrame:SetScript("OnLeave", function()
			GameTooltip:Hide()
		end)
		
		if not encounterFrame.data then encounterFrame.data = {}; end
		
		for actorIndex=1,#actorListByIndex do
			-- Creation of FontString objects if not existing
			if not encounterFrame.data[actorIndex] then
				encounterFrame.data[actorIndex] = {}
				-- Creation of Mana return efficiency fontstring
				encounterFrame.data[actorIndex].manaE = encounterFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
				encounterFrame.data[actorIndex].manaE:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
				encounterFrame.data[actorIndex].manaE:SetTextColor(1.0,1.0,1.0,1.0)
				-- Creation of Mind Blast cooldown management efficiency fontstring
				encounterFrame.data[actorIndex].mbE = encounterFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
				encounterFrame.data[actorIndex].mbE:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
				encounterFrame.data[actorIndex].mbE:SetTextColor(1.0,1.0,1.0,1.0)
				-- Creation of Shadow Word: Death cooldown management efficiency fontstring
				encounterFrame.data[actorIndex].swdE = encounterFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
				encounterFrame.data[actorIndex].swdE:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
				encounterFrame.data[actorIndex].swdE:SetTextColor(1.0,1.0,1.0,1.0)
				-- Creation of Warnings
				encounterFrame.data[actorIndex].warnings = {}
				for i = 1, HISTORY_WARNINGNUMBER do
					encounterFrame.data[actorIndex].warnings[i] = self:createWarningButton(
						encounterFrame,
						colIndex.."_"..actorIndex.."_"..i
					)
				end
			end
			
			-- Positionning of FontString and warning buttons
			local fontOffsetY = HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
				(HISTORY_CONTENT_HEIGHT + HISTORY_CONTENT_PADDINGY) * (actorIndex - 1)
			encounterFrame.data[actorIndex].manaE:SetPoint("TOPRIGHT",encounterFrame,"TOPRIGHT", -HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY - fontOffsetY)
			fontOffsetY = HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
				HISTORY_CONTENT_HEIGHT * #actorListByIndex + HISTORY_CONTENT_PADDINGY * (#actorListByIndex -1) + HISTORY_HEADER_PADDINGY +
				(HISTORY_CONTENT_HEIGHT + HISTORY_CONTENT_PADDINGY) * (actorIndex - 1)
			encounterFrame.data[actorIndex].mbE:SetPoint("TOPRIGHT",encounterFrame,"TOPRIGHT", -HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY - fontOffsetY)
			fontOffsetY = HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
				(HISTORY_CONTENT_HEIGHT * #actorListByIndex + HISTORY_CONTENT_PADDINGY * (#actorListByIndex -1) + HISTORY_HEADER_PADDINGY) * 2 +
				(HISTORY_CONTENT_HEIGHT + HISTORY_CONTENT_PADDINGY) * (actorIndex - 1)
			encounterFrame.data[actorIndex].swdE:SetPoint("TOPRIGHT",encounterFrame,"TOPRIGHT", -HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY - fontOffsetY)
			
			--encounterFrame.data[actorIndex].hazardousSwd:SetPoint("TOPRIGHT",encounterFrame,"TOPRIGHT", -HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY - fontOffsetY)
						
			local actorStat = encounter.actor[actorListByIndex[actorIndex]]
			
			if actorStat then
				-- Display of Mana return efficiency
				encounterFrame.data[actorIndex].manaE:SetFormattedText("%.1f %%",actorStat.manaReturnEfficiency*100)
				if actorStat.manaReturnEfficiency*100 < self.db.profile.vtThreshold then
					encounterFrame.data[actorIndex].manaE:SetTextColor(1.0,0.3,0.3,1.0)
				else
					encounterFrame.data[actorIndex].manaE:SetTextColor(1.0,1.0,1.0,1.0)
				end
				-- Display of Mind Blast cooldown management efficiency
				encounterFrame.data[actorIndex].mbE:SetFormattedText("%.1f %%",actorStat.mbEfficiency*100)
				if actorStat.mbEfficiency*100 < self.db.profile.mbThreshold then
					encounterFrame.data[actorIndex].mbE:SetTextColor(1.0,0.3,0.3,1.0)
				else
					encounterFrame.data[actorIndex].mbE:SetTextColor(1.0,1.0,1.0,1.0)
				end
				-- Display of Shadow Word: Death cooldown management efficiency
				encounterFrame.data[actorIndex].swdE:SetFormattedText("%.1f %%",actorStat.swdEfficiency*100)
				if actorStat.swdEfficiency*100 < self.db.profile.swdThreshold then
					encounterFrame.data[actorIndex].swdE:SetTextColor(1.0,0.3,0.3,1.0)
				else
					encounterFrame.data[actorIndex].swdE:SetTextColor(1.0,1.0,1.0,1.0)
				end
				-------------------------------------
				-- Placement of warnings
				local warningIndex = 0
				-- Hazardous SWD
				if actorStat.hazardousSwdNumber > 0 then
					warningIndex = warningIndex + 1
					local warningButton = encounterFrame.data[actorIndex].warnings[warningIndex]
					
					local warningOffsetY = HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
						(HISTORY_CONTENT_HEIGHT * #actorListByIndex + HISTORY_CONTENT_PADDINGY * (#actorListByIndex -1) + HISTORY_HEADER_PADDINGY) * 3 +
						(HISTORY_CONTENT_HEIGHT + HISTORY_CONTENT_PADDINGY) * (actorIndex - 1)
					local warningOffsetX = (warningIndex - 1) * HISTORY_WARNINGICON_WIDTH
					warningButton:SetPoint("TOPRIGHT",encounterFrame,"TOPRIGHT",  -HISTORY_TEXT_PADDINGX-warningOffsetX, - warningOffsetY)
					warningButton:SetNormalTexture(HISTORY_ICONPATH_HAZARDOUSSWD)
					--theFrame.deleteButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
					warningButton:SetWidth(HISTORY_WARNINGICON_WIDTH)
					warningButton:SetHeight(HISTORY_WARNINGICON_HEIGHT)
					warningButton.tooltipText = string.format(L["warning_tooltip_hazardousswd"], actorStat.hazardousSwdNumber, actorStat.swdNumber)
					warningButton:Show()
				end
				-- Deaths
				if actorStat.deaths > 0 then
					warningIndex = warningIndex + 1
					local warningButton = encounterFrame.data[actorIndex].warnings[warningIndex]
					
					local warningOffsetY = HISTORY_COLHEADER_HEIGHT + HISTORY_HEADER_PADDINGY +
						(HISTORY_CONTENT_HEIGHT * #actorListByIndex + HISTORY_CONTENT_PADDINGY * (#actorListByIndex -1) + HISTORY_HEADER_PADDINGY) * 3 +
						(HISTORY_CONTENT_HEIGHT + HISTORY_CONTENT_PADDINGY) * (actorIndex - 1)
					local warningOffsetX = (warningIndex - 1) * HISTORY_WARNINGICON_WIDTH
					warningButton:SetPoint("TOPRIGHT",encounterFrame,"TOPRIGHT",  -HISTORY_TEXT_PADDINGX-warningOffsetX, - warningOffsetY)
					warningButton:SetNormalTexture(HISTORY_ICONPATH_DEATHS)
					--theFrame.deleteButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
					warningButton:SetWidth(HISTORY_WARNINGICON_WIDTH)
					warningButton:SetHeight(HISTORY_WARNINGICON_HEIGHT)
					warningButton.tooltipText = string.format(L["warning_tooltip_deaths"], actorStat.deaths)
					warningButton:Show()
				end
				-- Cleaning up unused warning icons
				for i = warningIndex+1, HISTORY_WARNINGNUMBER do
					local warningButton = encounterFrame.data[actorIndex].warnings[i]
					warningButton:Hide()
				end
			else
				for objName, obj in pairs(encounterFrame.data[actorIndex]) do
					if objName == "warnings" then
						for _, warningButton in pairs(obj) do
							warningButton:Hide()
						end
					else
						obj:SetText("-")
					end
				end
			end
		end
		-- Cleanup of unused font strings
		for actorIndex=#actorListByIndex+1, #encounterFrame.data do
			-- Mana return efficiency
			encounterFrame.data[actorIndex].manaE:SetText("")
			-- Mind Blast cooldown management efficiency
			encounterFrame.data[actorIndex].mbE:SetText("")
			-- Shadow Word: Death cooldown management efficiency
			encounterFrame.data[actorIndex].swdE:SetText("")
			-- Warnings
			for _, warningButton in pairs(encounterFrame.data[actorIndex].warnings) do
				warningButton:Hide()
			end
		end
		encounterFrame:Show()
	end
	-- Cleanup unused frames / fontstrings (we conserve them for performance reasons)
	for colIndex=#encounters+1, #self.historyFrame.encounterFrames do
		local encounterFrame = self.historyFrame.encounterFrames[colIndex]
		encounterFrame:Hide()
	end
end

function ShadowFriend:createWarningButton(encounterFrame, frameNameString)
	local warningButton = CreateFrame("Button", "ShadowFriend_History_WarningButton_"..frameNameString, encounterFrame)
	
	warningButton:SetScript("OnClick", function() end)
	
	warningButton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText(this.tooltipText)
		GameTooltip:Show()
	end)
	warningButton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	
	return warningButton
end

function ShadowFriend:createEncounterFrame(colIndex)--, actorNumber)
	----------------------------------------------------------------------------
	-- Create Frame and set basic stuff
	local theFrame=CreateFrame("Frame","ShadowFriend_historyEncounterFrame_" .. colIndex, self.historyFrame)

	theFrame:ClearAllPoints()
	theFrame:SetPoint("TOPLEFT", self.historyFrame, "TOPLEFT", 
		HISTORY_CONTENT_OFFSETX + 
			HISTORY_ROWHEADER1_WIDTH + HISTORY_HEADER_PADDINGX + 
			HISTORY_ROWHEADER2_WIDTH + HISTORY_HEADER_PADDINGX + 
			(HISTORY_CONTENT_WIDTH + HISTORY_CONTENT_PADDINGX) * (colIndex-1),
		HISTORY_CONTENT_OFFSETY
	)
	theFrame:SetWidth(HISTORY_CONTENT_WIDTH)
	
	-- TODO cleanup textures from recount
	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = nil,
		edgeSize = 0,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	theFrame:SetBackdropColor(200/255, 200/255, 200/255, 0.25 * (colIndex % 2))
	
	-- Create fontstrings
	theFrame.title1=theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	theFrame.title1:SetPoint("TOPLEFT",theFrame,"TOPLEFT", HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY)
	theFrame.title1:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
	theFrame.title1:SetTextColor(1.0,1.0,0,1.0)
	
	theFrame.title2=theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	theFrame.title2:SetPoint("TOPLEFT",theFrame,"TOPLEFT", HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY - 13)
	theFrame.title2:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
	theFrame.title2:SetTextColor(1.0,1.0,0,1.0)
	
	----------------------------------------------------------------------------
	-- Create Delete data button
	theFrame.deleteButton = CreateFrame("Button", "ShadowFriend_History_DeleteDataButton_"..colIndex, theFrame)
	theFrame.deleteButton:SetPoint("TOPRIGHT",theFrame,"TOPRIGHT", -HISTORY_TEXT_PADDINGX, -5)
	theFrame.deleteButton:SetNormalTexture("Interface\\Addons\\Recount\\Textures\\icon-reset")
	theFrame.deleteButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	theFrame.deleteButton:SetWidth(16)
	theFrame.deleteButton:SetHeight(16)
	theFrame.deleteButton.encounterIndex = colIndex
	theFrame.deleteButton:SetScript("OnClick", function()
		if #ShadowFriend.db.profile.history[ShadowFriend.db.profile.historySelectedBoss] ~= 1 then
			ShadowFriend:deleteHistoryEncounter(ShadowFriend.db.profile.historySelectedBoss, this.encounterIndex)
		else
			local deleteButton = theFrame:GetParent().deleteButton
			if deleteButton:IsVisible() then
				deleteButton:Click()
			end
		end
		ShadowFriend:refreshHistoryContent()
	end)
	-- SET tooltip
	theFrame.deleteButton:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		GameTooltip:SetText(L["delete_fight_tooltip"])
		GameTooltip:Show()
	end)
	theFrame.deleteButton:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	
	theFrame:EnableMouse(true)
	theFrame:SetScript("OnEnter", function()
		if this.isCursorOnHeaderframe then
			GameTooltip:SetText(this.description)
		end
	end)
	
	----------------------------------------------------------------------------
	-- Create tooltip Frame
	theFrame.tooltipFrame=CreateFrame("Frame","ShadowFriend_historyEncounterTooltipFrame_" .. colIndex, theFrame)
	theFrame.tooltipFrame:ClearAllPoints()
	theFrame.tooltipFrame:SetPoint("TOPLEFT", theFrame, "TOPLEFT", 0, 0)
	theFrame.tooltipFrame:SetWidth(HISTORY_CONTENT_WIDTH)
	theFrame.tooltipFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = nil,
		edgeSize = 0,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	theFrame.tooltipFrame:SetBackdropColor(0, 0, 0, 0)
	
	return theFrame
end

function ShadowFriend:createColumnHeaderBgFrame()
	----------------------------------------------------------------------------
	-- Create Frame and set basic stuff
	local theFrame=CreateFrame("Frame","ShadowFriend_ColumnHeaderBgrame", self.historyFrame)

	theFrame:ClearAllPoints()
	theFrame:SetPoint("TOPLEFT", self.historyFrame, "TOPLEFT", 
		HISTORY_CONTENT_OFFSETX + 
			HISTORY_ROWHEADER1_WIDTH + HISTORY_HEADER_PADDINGX + 
			HISTORY_ROWHEADER2_WIDTH + HISTORY_HEADER_PADDINGX ,
		HISTORY_CONTENT_OFFSETY
	)
	theFrame:SetHeight(HISTORY_COLHEADER_HEIGHT)
	
	-- TODO cleanup textures from recount
	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = nil,
		edgeSize = 0,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	theFrame:SetBackdropColor(0, 0, 1, 0.5)
	
	return theFrame
end

function ShadowFriend:createRowHeaderBgFrame()
	----------------------------------------------------------------------------
	-- Create Frame and set basic stuff
	local theFrame=CreateFrame("Frame","ShadowFriend_RowHeaderBgrame", self.historyFrame)

	theFrame:ClearAllPoints()
	theFrame:SetPoint("TOPLEFT", self.historyFrame, "TOPLEFT", 
		HISTORY_CONTENT_OFFSETX,
		HISTORY_CONTENT_OFFSETY - 
			HISTORY_COLHEADER_HEIGHT - HISTORY_HEADER_PADDINGY
	)
	theFrame:SetWidth(HISTORY_ROWHEADER1_WIDTH + HISTORY_ROWHEADER2_WIDTH + HISTORY_HEADER_PADDINGX * 2)
	
	-- TODO cleanup textures from recount
	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = nil,
		edgeSize = 0,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	theFrame:SetBackdropColor(1, 0, 0, 0.5)
	
	return theFrame
end

function ShadowFriend:createActorBgFrames(actorIndex)--, actorNumber, encounterNumber)
	local theFrames = {}
	
	for dataIndex = 1, HISTORY_DATANUMBER do 
		-- Create Frame and set basic stuff
		theFrames[dataIndex]=CreateFrame("Frame","ShadowFriend_ActorBgFrame_"..actorIndex.."_"..dataIndex, self.historyFrame)
	
		theFrames[dataIndex]:ClearAllPoints()
		
		theFrames[dataIndex]:SetHeight(HISTORY_CONTENT_HEIGHT)
		
		theFrames[dataIndex]:SetBackdrop({
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			tile = true,
			tileSize = 16,
			edgeFile = nil,
			edgeSize = 0,
			insets = {left = 0, right = 0, top = 0, bottom = 0},
		})
		-- Create font string for actor name
		theFrames[dataIndex].title = theFrames[dataIndex]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		theFrames[dataIndex].title:SetPoint("TOPLEFT",theFrames[dataIndex],"TOPLEFT", HISTORY_TEXT_PADDINGX, -HISTORY_TEXT_PADDINGY)
		theFrames[dataIndex].title:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
		theFrames[dataIndex].title:SetTextColor(1.0,1.0,0,1.0)	
	end
	
	return theFrames
end

function ShadowFriend:createDataBgFrames(statIndex)
	----------------------------------------------------------------------------
	-- Create Frame and set basic stuff
	local theFrame=CreateFrame("Frame","ShadowFriend_DataBgFrame_"..statIndex, self.historyFrame)

	theFrame:ClearAllPoints()
	
	-- TODO cleanup textures from recount
	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = nil,
		edgeSize = 0,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	theFrame:SetBackdropColor(200/255, 200/255, 255/255, 0.5)
	
	-- Create font string for data name
	theFrame.title = theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	theFrame.title:SetFont(HISTORY_FONT_FACE, HISTORY_FONT_SIZE)
	theFrame.title:SetTextColor(1.0,1.0,0,1.0)	
	
	----------------------------------------------------------------------------
	-- Create Ghost frame to support tooltip
	local tooltipFrame=CreateFrame("Frame","ShadowFriend_DataBgTooltipFrame_"..statIndex, theFrame)
	tooltipFrame:ClearAllPoints()
	tooltipFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		tile = true,
		tileSize = 16,
		edgeFile = nil,
		edgeSize = 0,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	tooltipFrame:SetBackdropColor(0, 0, 0, 0)
	-- SET tooltip
	tooltipFrame:EnableMouse(true)
	tooltipFrame:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this, "ANCHOR_CURSOR")
		GameTooltip:ClearLines()
		--GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
		GameTooltip:SetText(this.description)
		GameTooltip:Show()
	end)
	tooltipFrame:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	
	theFrame.tooltipFrame = tooltipFrame
	
	return theFrame
end

-- Shamelessly plugged from recount
function ShadowFriend:SetupScrollbar(name)
	local Thumb=getglobal(name.."ScrollBarThumbTexture")
	Thumb:SetTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-Knob")
	Thumb:SetVertexColor(1,0,0)

	local Up=getglobal(name.."ScrollBarScrollUpButton")
	Up:SetNormalTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollUpButton-Up")
	Up:SetPushedTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollUpButton-Up")
	Up:SetDisabledTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollUpButton-Disabled")
	Up:SetHighlightTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollUpButton-Highlight")

	if not Up.Overlay then
		Up.Overlay=Up:CreateTexture(nil,"OVERLAY")
		Up.Overlay:SetAllPoints(Up)
		Up.Overlay:SetTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollUpButton-Overlay")
		Up.Overlay:SetVertexColor(1,0,0)
		Up.Overlay:SetTexCoord(0.25,0.75,0.25,0.75)
		Up.Overlay:SetBlendMode("MOD")
	end

	local Down=getglobal(name.."ScrollBarScrollDownButton")
	Down:SetNormalTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollDownButton-Up")
	Down:SetPushedTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollDownButton-Up")
	Down:SetDisabledTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollDownButton-Disabled")
	Down:SetHighlightTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollDownButton-Highlight")

	if not Down.Overlay then
		Down.Overlay=Up:CreateTexture(nil,"OVERLAY")
		Down.Overlay:SetAllPoints(Down)
		Down.Overlay:SetTexture("Interface\\AddOns\\ShadowFriend\\textures\\scrollbar\\UI-ScrollBar-ScrollDownButton-Overlay")
		Down.Overlay:SetVertexColor(1,0,0)
		Down.Overlay:SetTexCoord(0.25,0.75,0.25,0.75)
		Down.Overlay:SetBlendMode("MOD")
	end
	
end
