local L = LibStub("AceLocale-3.0"):GetLocale("ShadowFriend")
local BB = LibStub("LibBabble-Boss-3.0"):GetUnstrictLookupTable() 
local BZ = LibStub("LibBabble-Zone-3.0"):GetUnstrictLookupTable() 

-- ========================================================================== --
-- Database for different tiers
-- ========================================================================== --
ShadowFriend_dungeonDatabase = {
    [BZ["Karazhan"]] = {
    	-- ================ Karazhan
    	[BB["Attumen the Huntsman"]] = BB["Attumen the Huntsman"],
		[BB["Dorothee"]] = BB["Dorothee"],
		[BB["Grandmother"]] = BB["The Big Bad Wolf"],
		[BB["Hyakiss the Lurker"]] = BB["Hyakiss the Lurker"],
		[BB["Julianne"]] = BB["Romulo & Julianne"],
		[BB["Kil'rek"]] = BB["Terestian Illhoof"],
		[BB["Maiden of Virtue"]] = BB["Maiden of Virtue"],
		[BB["Midnight"]] = BB["Attumen the Huntsman"],
		[BB["Moroes"]] = BB["Moroes"],
		[BB["Netherspite"]] = BB["Netherspite"],
		[BB["Nightbane"]] = BB["Nightbane"],
		[BB["Restless Skeleton"]] = BB["Nightbane"],
		[BB["Prince Malchezaar"]] = BB["Prince Malchezaar"],
		[BB["Roar"]] = BB["Dorothee"],
		[BB["Rokad the Ravager"]] = BB["Rokad the Ravager"],
		[BB["Romulo"]] = BB["Romulo & Julianne"],
		[BB["Shade of Aran"]] = BB["Shade of Aran"],
		[BB["Shadikith the Glider"]] = BB["Shadikith the Glider"],
		[BB["Strawman"]] = BB["Dorothee"],
		[BB["Terestian Illhoof"]] = BB["Terestian Illhoof"],
		[BB["The Big Bad Wolf"]] = BB["The Big Bad Wolf"],
		[BB["The Crone"]] = BB["Dorothee"],
		[BB["The Curator"]] = BB["The Curator"],
		[BB["Tinhead"]] = BB["Dorothee"],
		[BB["Tito"]] = BB["Dorothee"],
    },
    [BZ["Zul'Aman"]] = {
    	-- ================ Zul Aman
    	[BB["Akil'zon"]] = BB["Akil'zon"],
		[BB["Halazzi"]] = BB["Halazzi"],
		[BB["Jan'alai"]] = BB["Jan'alai"],
		[BB["Malacrass"]] = BB["Malacrass"],
		[BB["Nalorakk"]] = BB["Nalorakk"],
		[BB["Zul'jin"]] = BB["Zul'jin"],
		[BB["Hex Lord Malacrass"]] = BB["Hex Lord Malacrass"],
    },
    [BZ["Gruul's Lair"]] = {
    	-- ================ Gruul's lair
    	-- Maulgar
    	[BB["Blindeye the Seer"]] = BB["High King Maulgar"],
		[BB["High King Maulgar"]] = BB["High King Maulgar"],
		[BB["Kiggler the Crazed"]] = BB["High King Maulgar"],
		[BB["Krosh Firehand"]] = BB["High King Maulgar"],
		[BB["Olm the Summoner"]] = BB["High King Maulgar"],
		-- Gruul
		[BB["Gruul the Dragonkiller"]] = BB["Gruul the Dragonkiller"],
	},
	[BZ["Magtheridon's Lair"]] = {
		-- ================ Magtheridon's lair
		-- Magtheridon
		[BB["Hellfire Channeler"]] = BB["Magtheridon"],
		[BB["Magtheridon"]] = BB["Magtheridon"],
	},
	[BZ["Serpentshrine Cavern"]] = {
		-- ================ SSC
		[BB["Coilfang Elite"]] = BB["Lady Vashj"],
		[BB["Coilfang Strider"]] = BB["Lady Vashj"],
		[BB["Fathom-Lord Karathress"]] = BB["Fathom-Lord Karathress"],
		[BB["Hydross the Unstable"]] = BB["Hydross the Unstable"],
		[BB["Lady Vashj"]] = BB["Lady Vashj"],
		[BB["Leotheras the Blind"]] = BB["Leotheras the Blind"],
		[BB["Morogrim Tidewalker"]] = BB["Morogrim Tidewalker"],
		[BB["Pure Spawn of Hydross"]] = BB["Hydross the Unstable"],
		[BB["Shadow of Leotheras"]] = BB["Leotheras the Blind"],
		[BB["Tainted Spawn of Hydross"]] = BB["Hydross the Unstable"],
		[BB["The Lurker Below"]] = BB["The Lurker Below"],
		[BB["Tidewalker Lurker"]] = BB["Morogrim Tidewalker"],
	},
	[BZ["Tempest Keep"]] = {
		-- ================ TK
		[BB["Al'ar"]] = BB["Al'ar"],
		[BB["Cosmic Infuser"]] = BB["Kael'thas Sunstrider"],
		[BB["Devastation"]] = BB["Kael'thas Sunstrider"],
		[BB["Grand Astromancer Capernian"]] = BB["Kael'thas Sunstrider"],
		[BB["High Astromancer Solarian"]] = BB["High Astromancer Solarian"],
		[BB["Infinity Blades"]] = BB["Kael'thas Sunstrider"],
		[BB["Kael'thas Sunstrider"]] = BB["Kael'thas Sunstrider"],
		[BB["Lord Sanguinar"]] = BB["Kael'thas Sunstrider"],
		[BB["Master Engineer Telonicus"]] = BB["Kael'thas Sunstrider"],
		[BB["Netherstrand Longbow"]] = BB["Kael'thas Sunstrider"],
		[BB["Phaseshift Bulwark"]] = BB["Kael'thas Sunstrider"],
		[BB["Solarium Agent"]] = BB["High Astromancer Solarian"],
		[BB["Solarium Priest"]] = BB["High Astromancer Solarian"],
		[BB["Staff of Disintegration"]] = BB["Kael'thas Sunstrider"],
		[BB["Thaladred the Darkener"]] = BB["Kael'thas Sunstrider"],
		[BB["Void Reaver"]] = BB["Void Reaver"],
		[BB["Warp Slicer"]] = BB["Kael'thas Sunstrider"],
	},
	[BZ["Hyjal Summit"]] = {
		-- ================ Hyjal
		[BB["Anetheron"]] = BB["Anetheron"],
		[BB["Archimonde"]] = BB["Archimonde"],
		[BB["Azgalor"]] = BB["Azgalor"],
		[BB["Kaz'rogal"]] = BB["Kaz'rogal"],
		[BB["Rage Winterchill"]] = BB["Rage Winterchill"],
	},
	[BZ["Black Temple"]] = {
		-- ================ BT
		[BB["Essence of Anger"]] = BB["Reliquary of Souls"],
		[BB["Essence of Desire"]] = BB["Reliquary of Souls"],
		[BB["Essence of Suffering"]] = BB["Reliquary of Souls"],
		[BB["Gathios the Shatterer"]] = BB["Illidari Council"],
		[BB["High Nethermancer Zerevor"]] = BB["Illidari Council"],
		[BB["Veras Darkshadow"]] = BB["Illidari Council"],
		[BB["Lady Malande"]] = BB["Illidari Council"],
		[BB["Gurtogg Bloodboil"]] = BB["Gurtogg Bloodboil"],
		[BB["High Warlord Naj'entus"]] = BB["High Warlord Naj'entus"],
		[BB["Illidan Stormrage"]] = BB["Illidan Stormrage"],
		[BB["Mother Shahraz"]] = BB["Mother Shahraz"],
		[BB["Shade of Akama"]] = BB["Shade of Akama"],
		[BB["Supremus"]] = BB["Supremus"],
		[BB["Teron Gorefiend"]] = BB["Teron Gorefiend"],
	},
	[BZ["Sunwell Plateau"]] = {
		-- ================ Sunwell
		[BB["Kalecgos"]] = BB["Kalecgos"],
		[BB["Sathrovarr the Corruptor"]] = BB["Kalecgos"],
		[BB["Brutallus"]] = BB["Brutallus"],
		[BB["Felmyst"]] = BB["Felmyst"],
		[BB["Kil'jaeden"]] = BB["Kil'jaeden"],
		[BB["M'uru"]] = BB["M'uru"],
		[BB["Entropius"]] = BB["M'uru"],
		[BB["Lady Sacrolash"]] = BB["The Eredar Twins"],
		[BB["Grand Warlock Alythess"]] = BB["The Eredar Twins"],
	},
}

